package xyz.zhouxy.plusone.commons.seq;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;
import java.util.function.Consumer;

import org.junit.jupiter.api.Test;

import com.google.common.collect.ImmutableList;

import lombok.extern.slf4j.Slf4j;

@Slf4j
class SeqTests {

    @Test
    void testSeq() {
        List<Integer> list = ImmutableList.of(108, 2333, 666, 555, 1, 2, 3, 23, 78, 65, 77, 22, 108);
        List<String> result = new ArrayList<>();
        Seq<String> targetSeq = new Seq<String>() {
            @Override
            public void accept(Consumer<String> c) {
                list.forEach(t -> {
                    c.accept(String.valueOf(t + 250));
                });
            }
        };
        targetSeq.accept(result::add);
        // list.forEach(t -> {
        // result.add(t + 250 + "");
        // });
        log.info("{}", result);

        for (Integer i : produceEvenNumbers(9)) {
            System.out.print(i);
            System.out.print(" ");
        }
        System.out.println();
        
        Set<String> set = new TreeSet<>();
        Seq<String> s = result::forEach;
        s.accept(set::add);
        log.info("{}", set);
    }

    Iterable<Integer> produceEvenNumbers(int upto) {
        Seq<Integer> seq = c -> {
            for (int i = 0; i <= upto; i += 2) {
                c.accept(i);
            }
        };
        return seq.toList();
    }
}
